## 	The size of the lexicon and the number of modeling units
l = len(abc_datasets_paths) 					# The total number of images in the database
n = len(characters_as_unit_counter)		# The total number of characters 
total_chars = len(characters_as_unit)

## The number of modeling units in each model (character)
## characters_as_unit_counter[c] is the number of times a particular character appears in the images

character_inv_prob = {c:(1 /(characters_as_unit_counter[c] / total_chars))  for c in list(characters_as_unit_counter.keys())}
W = {}
W_normalized = {}

## W = {word: x for prob in character_inv_prob for path in abc_datasets_paths}

weight_sum = 0.0
for path in abc_datasets_paths:
    label = os.path.basename(path)

## labels[label]['CharsAsUnit'] is a list of the characters in the image, for example, ['Alif', 'Lam', 'Meem',....]
    W[label] = np.sum([character_inv_prob[model] for model in labels[label]['CharsAsUnit']]) / len(labels[label]['CharsAsUnit']) 
    weight_sum += W[label]

for label in W:
    W_normalized[label] = W[label] / weight_sum